#ifndef __IPV4_HOST
#define __IPV4_HOST

#include "ipv4_adr.h"

class ipv4_host 
{
private:
    ipv4_adr host_adr;
    string host_name;
public:
    ipv4_host() { };
    explicit ipv4_host(unsigned int a) : host_adr(a) { };
    explicit ipv4_host(const ipv4_adr &a) : host_adr(a) { };
    explicit ipv4_host(const string &h);
    explicit ipv4_host(struct in_addr *a) : host_adr(a) { };
    ipv4_host(int w, int x, int y, int z) : host_adr(w, x, y, z) { };
    ipv4_host(const ipv4_host &other) : host_adr(other.host_adr), host_name(other.host_name) { };
    ipv4_host &operator=(const ipv4_host other)
        {   host_adr=other.host_adr;
            host_name=other.host_name;
            return *this;
        }
    const ipv4_adr &get_adr() const { return host_adr; };
    const string &get_name() const { return host_name; };
    int get_adr_int() const { return host_adr.get(); };
    int get_adr_n() const { return host_adr.get_n(); };
    string str() const;
    string str_with_adr() const;
    static string parse_error_string() { return "host name or IPv4 address in a.b.c.d form expected"; };
    const ipv4_adr &refresh();
};

std::ostream& operator<<(std::ostream &str, const ipv4_host &host);
std::istream& operator>>(std::istream &str, ipv4_host &host);

#endif
